import java.awt.Container;
import java.awt.GridLayout;
import java.awt.BorderLayout;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JLabel;

import javax.swing.JList;
import javax.swing.JScrollPane;

public class ExampleUI {
  Container c;
  Sorter[] sorters;
  String[] data;
  public ExampleUI(Sorter[] sorters, String[] data) {
    this.sorters = sorters;
    this.data = data;
  }
  public void show() {
    JFrame f = createFrame();
    addUnsortedData();
    runSorters();
    f.setSize(1000, 800);
    f.setVisible(true);
  }
  private JFrame createFrame() {
    JFrame f = new JFrame();
    f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    f.setTitle("Uebung 10 - Sortieren");    
    c = f.getContentPane();
    c.setLayout(new GridLayout(2, (int) Math.ceil(sorters.length/2), 0, 1));
    return f;
  }
  private void addUnsortedData() {
    c.add(createPanel(data, "Unsortiert"));
  }
  private void runSorters() {
    final int REPEAT = 50;
    for(Sorter s: sorters) {
      Timer t = Timer.start();
      String[] sorted = null;
      for(int i=0; i < REPEAT; i++) {
        t.pause();
        sorted = data.clone();
        t.continu();
        s.sort(sorted);
      }
      t.stop();
      c.add(createPanel(sorted, 
        String.format("%s - %dms", s.getClass().getName(), t.getTime())));
    }
  }
  private JComponent createPanel(String[] data, String label) {
    JPanel p = new JPanel();
    BorderLayout bl = new BorderLayout();
    p.setLayout(bl);
    p.add(new JLabel(label), BorderLayout.NORTH);
    JList text = new JList(data);
    JScrollPane scroll = new JScrollPane(text);
    p.add(scroll, BorderLayout.CENTER);
    return p;
  }
}