public class Test {
  enum TestMode {
    INTEGERS_1000,
    CITIES_50,
    COUNTIES_3000,
  }
  public static void main(String[] args) {
    Sorter[] sorters = new Sorter[] {
      new BubbleSort(),
      new SelectionSort(),
      new InsertionSort(),
      new MergeSort(),
      new QuickSort(),
      new HeapSort(),
    };

    final TestMode testMode = TestMode.CITIES_50;
    switch(testMode) {
      case CITIES_50:
        new ExampleUI(sorters, readData("Cities.txt")).show();
        break;
      case COUNTIES_3000:
        new ExampleUI(sorters, readData("Counties.txt")).show();
        break;
    }
  }
  private static String[] readData(String filename) {
    In.open(filename);
    int cnt = In.readInt(); In.readLine();
    String[] data = new String[cnt];
    int i=0;
    while(In.done() && i < cnt) {
      String s = In.readLine();
      // remove CRLF
      data[i] = s.substring(0, s.length()-1);
      i++;
    }
    assert(cnt == i);
    In.close();
    return data;
  }
}